

#include <windows.h>
#ifdef __cplusplus
  extern "C"
#endif
#ifdef _MSC_VER
  __declspec(dllimport)
#endif
int __cdecl sprintf(char*, const char*, ...);


typedef LONG NTSTATUS;

typedef void * __ptr32 P32VOID;
typedef void * __ptr32 LP32VOID;
typedef const void * __ptr32 P32CVOID;
typedef const void * __ptr32 LP32CVOID;
typedef void * __ptr32 HANDLE32;
typedef void * __ptr32 HMODULE32;
typedef void * __ptr32 HINSTANCE32;
typedef unsigned char * __ptr32 P32BYTE;
typedef unsigned char * __ptr32 LP32BYTE;
typedef char * __ptr32 P32STR;
typedef char * __ptr32 LP32STR;
typedef short * __ptr32 P32WSTR;
typedef short * __ptr32 LP32WSTR;
typedef void * __ptr64 P64VOID;
typedef void * __ptr64 LP64VOID;
typedef const void * __ptr64 P64CVOID;
typedef const void * __ptr64 LP64CVOID;
typedef void * __ptr64 HANDLE64;
typedef void * __ptr64 HMODULE64;
typedef void * __ptr64 HINSTANCE64;
typedef unsigned char * __ptr64 P64BYTE;
typedef unsigned char * __ptr64 LP64BYTE;
typedef char * __ptr64 P64STR;
typedef char * __ptr64 LP64STR;
typedef short * __ptr64 P64WSTR;
typedef short * __ptr64 LP64WSTR;

typedef NT_TIB32 * PTEB32_;
typedef NT_TIB32 * LPTEB32_;
typedef NT_TIB32 * __ptr32 P32TEB32_;
typedef NT_TIB32 * __ptr32 LP32TEB32_;
typedef NT_TIB32 * __ptr64 P64TEB32_;
typedef NT_TIB32 * __ptr64 LP64TEB32_;
typedef NT_TIB64 * PTEB64_;
typedef NT_TIB64 * LPTEB64_;
typedef NT_TIB64 * __ptr32 P32TEB64_;
typedef NT_TIB64 * __ptr32 LP32TEB64_;
typedef NT_TIB64 * __ptr64 P64TEB64_;
typedef NT_TIB64 * __ptr64 LP64TEB64_;


typedef struct _LIST_ENTRY32_ {
  struct _LIST_ENTRY32_ * __ptr32 Flink;
  struct _LIST_ENTRY32_ * __ptr32 Blink;
} LIST_ENTRY32_, *PLIST_ENTRY32_, *LPLIST_ENTRY32_,
  * __ptr32 P32LIST_ENTRY32_, * __ptr32 LP32LIST_ENTRY32_,
  * __ptr64 P64LIST_ENTRY32_, * __ptr64 LP64LIST_ENTRY32_;

typedef struct _LIST_ENTRY64_ {
  struct _LIST_ENTRY64_ * __ptr64 Flink;
  struct _LIST_ENTRY64_ * __ptr64 Blink;
} LIST_ENTRY64_, *PLIST_ENTRY64_, *LPLIST_ENTRY64_,
  * __ptr32 P32LIST_ENTRY64_, * __ptr32 LP32LIST_ENTRY64_,
  * __ptr64 P64LIST_ENTRY64_, * __ptr64 LP64LIST_ENTRY64_;

typedef struct _LIST_ENTRY_ {
  struct _LIST_ENTRY_ * Flink;
  struct _LIST_ENTRY_ * Blink;
} LIST_ENTRY_, *PLIST_ENTRY_, *LPLIST_ENTRY_,
  * __ptr32 P32LIST_ENTRY_, * __ptr32 LP32LIST_ENTRY_,
  * __ptr64 P64LIST_ENTRY_, * __ptr64 LP64LIST_ENTRY_;


typedef struct _UNICODE_STRING32_ {
  USHORT Length;
  USHORT MaximumLength;
  P32WSTR Buffer;
} UNICODE_STRING32_, *PUNICODE_STRING32_, *LPUNICODE_STRING32_,
  * __ptr32 P32UNICODE_STRING32_, * __ptr32 LP32UNICODE_STRING32_,
  * __ptr64 P64UNICODE_STRING32_, * __ptr64 LP64UNICODE_STRING32_;

typedef struct _UNICODE_STRING64_ {
  USHORT Length;
  USHORT MaximumLength;
  DWORD align1;
  P64WSTR Buffer;
} UNICODE_STRING64_, *PUNICODE_STRING64_, *LPUNICODE_STRING64_,
  * __ptr32 P32UNICODE_STRING64_, * __ptr32 LP32UNICODE_STRING64_,
  * __ptr64 P64UNICODE_STRING64_, * __ptr64 LP64UNICODE_STRING64_;

typedef struct _UNICODE_STRING_ {
  USHORT Length;
  USHORT MaximumLength;
  PWSTR Buffer;
} UNICODE_STRING_, *PUNICODE_STRING_, *LPUNICODE_STRING_,
  * __ptr32 P32UNICODE_STRING_, * __ptr32 LP32UNICODE_STRING_,
  * __ptr64 P64UNICODE_STRING_, * __ptr64 LP64UNICODE_STRING_;


typedef struct _LDR_DATA_TABLE_ENTRY32_ {
  LIST_ENTRY32_ InLoadOrderLinks;
  LIST_ENTRY32_ InMemoryOrderLinks;
  LIST_ENTRY32_ InInitializationOrderLinks;
  P32VOID DllBase;
  P32VOID EntryPoint;
  ULONG SizeOfImage;
  UNICODE_STRING32_ FullDllName;
  UNICODE_STRING32_ BaseDllName;
  ULONG Flags;
  USHORT LoadCount;
  USHORT TlsIndex;
  union {
    LIST_ENTRY32_ HashLinks;
    struct {
      P32VOID SectionPointer;
      ULONG CheckSum;
    } s;
  } u;
  ULONG TimeDateStamp;
  //etc...
} LDR_DATA_TABLE_ENTRY32_, *PLDR_DATA_TABLE_ENTRY32_, *LPLDR_DATA_TABLE_ENTRY32_,
  * __ptr32 P32LDR_DATA_TABLE_ENTRY32_, * __ptr32 LP32LDR_DATA_TABLE_ENTRY32_,
  * __ptr64 P64LDR_DATA_TABLE_ENTRY32_, * __ptr64 LP64LDR_DATA_TABLE_ENTRY32_;

typedef struct _LDR_DATA_TABLE_ENTRY64_ {
  LIST_ENTRY64_ InLoadOrderLinks;
  LIST_ENTRY64_ InMemoryOrderLinks;
  LIST_ENTRY64_ InInitializationOrderLinks;
  P64VOID DllBase;
  P64VOID EntryPoint;
  ULONGLONG SizeOfImage;
  UNICODE_STRING64_ FullDllName;
  UNICODE_STRING64_ BaseDllName;
  ULONG Flags;
  USHORT LoadCount;
  USHORT TlsIndex;
  union {
    LIST_ENTRY64_ HashLinks;
    struct {
      P64VOID SectionPointer;
      ULONG CheckSum;
    } s;
  } u;
  ULONG TimeDateStamp;
  //etc...
} LDR_DATA_TABLE_ENTRY64_, *PLDR_DATA_TABLE_ENTRY64_, *LPLDR_DATA_TABLE_ENTRY64_,
  * __ptr32 P32LDR_DATA_TABLE_ENTRY64_, * __ptr32 LP32LDR_DATA_TABLE_ENTRY64_,
  * __ptr64 P64LDR_DATA_TABLE_ENTRY64_, * __ptr64 LP64LDR_DATA_TABLE_ENTRY64_;


typedef struct _LDR_DATA_TABLE_ENTRY_ {
  LIST_ENTRY_ InLoadOrderLinks;
  LIST_ENTRY_ InMemoryOrderLinks;
  LIST_ENTRY_ InInitializationOrderLinks;
  PVOID DllBase;
  PVOID EntryPoint;
  ULONG_PTR SizeOfImage;
  UNICODE_STRING_ FullDllName;
  UNICODE_STRING_ BaseDllName;
  ULONG Flags;
  USHORT LoadCount;
  USHORT TlsIndex;
  union {
    LIST_ENTRY32_ HashLinks;
    struct {
      P32VOID SectionPointer;
      ULONG CheckSum;
    } s;
  } u;
  ULONG TimeDateStamp;
  //etc...
} LDR_DATA_TABLE_ENTRY_, *PLDR_DATA_TABLE_ENTRY_, *LPLDR_DATA_TABLE_ENTRY_,
  * __ptr32 P32LDR_DATA_TABLE_ENTRY_, * __ptr32 LP32LDR_DATA_TABLE_ENTRY_,
  * __ptr64 P64LDR_DATA_TABLE_ENTRY_, * __ptr64 LP64LDR_DATA_TABLE_ENTRY_;


typedef struct _PEB_LDR_DATA32_ {
  DWORD Length;
  BYTE Initialized;
  BYTE Dummy[3];
  HANDLE32 SsHandle;
  LIST_ENTRY32_ InLoadOrderModuleList;
  LIST_ENTRY32_ InMemoryOrderModuleList;
  LIST_ENTRY32_ InInitializationOrderModuleList;
} PEB_LDR_DATA32_, *PPEB_LDR_DATA32_, *LPPEB_LDR_DATA32_,
  * __ptr32 P32PEB_LDR_DATA32_, * __ptr32 LP32PEB_LDR_DATA32_,
  * __ptr64 P64PEB_LDR_DATA32_, * __ptr64 LP64PEB_LDR_DATA32_;

typedef struct _PEB_LDR_DATA64_ {
  DWORD Length;
  BYTE Initialized;
  BYTE Dummy[3];
  HANDLE64 SsHandle;
  LIST_ENTRY64_ InLoadOrderModuleList;
  LIST_ENTRY64_ InMemoryOrderModuleList;
  LIST_ENTRY64_ InInitializationOrderModuleList;
} PEB_LDR_DATA64_, *PPEB_LDR_DATA64_, *LPPEB_LDR_DATA64_,
  * __ptr32 P32PEB_LDR_DATA64_, * __ptr32 LP32PEB_LDR_DATA64_,
  * __ptr64 P64PEB_LDR_DATA64_, * __ptr64 LP64PEB_LDR_DATA64_;

typedef struct _PEB_LDR_DATA_ {
  DWORD Length;
  BYTE Initialized;
  BYTE Dummy[3];
  HANDLE SsHandle;
  LIST_ENTRY_ InLoadOrderModuleList;
  LIST_ENTRY_ InMemoryOrderModuleList;
  LIST_ENTRY_ InInitializationOrderModuleList;
} PEB_LDR_DATA_, *PPEB_LDR_DATA_, *LPPEB_LDR_DATA_,
  * __ptr32 P32PEB_LDR_DATA_, * __ptr32 LP32PEB_LDR_DATA_,
  * __ptr64 P64PEB_LDR_DATA_, * __ptr64 LP64PEB_LDR_DATA_;

typedef struct _PEB32_ {
  BYTE InheritedAddressSpace;
  BYTE ReadImageFileExecOptions;
  BYTE BeingDebugged;
  BYTE SpareBool;
  HANDLE32 Mutant;
  HMODULE32 ImageBaseAddress;
  P32PEB_LDR_DATA32_ Ldr;
  //etc...
} PEB32_, *PPEB32_, *LPPEB32_,
  * __ptr32 P32PEB32_, * __ptr32 LP32PEB32_,
  * __ptr64 P64PEB32_, * __ptr64 LP64PEB32_;

typedef struct _PEB64_ {
  BYTE InheritedAddressSpace;
  BYTE ReadImageFileExecOptions;
  BYTE BeingDebugged;
  BYTE SpareBool;
  HANDLE64 Mutant;
  HMODULE64 ImageBaseAddress;
  P64PEB_LDR_DATA64_ Ldr;
  //etc...
} PEB64_, *PPEB64_, *LPPEB64_,
  * __ptr32 P32PEB64_, * __ptr32 LP32PEB64_,
  * __ptr64 P64PEB64_, * __ptr64 LP64PEB64_;

typedef struct _PEB_ {
  BYTE InheritedAddressSpace;
  BYTE ReadImageFileExecOptions;
  BYTE BeingDebugged;
  BYTE SpareBool;
  HANDLE Mutant;
  HMODULE ImageBaseAddress;
  PPEB_LDR_DATA_ Ldr;
  //etc...
} PEB_, *PPEB_, *LPPEB_,
  * __ptr32 P32PEB_, * __ptr32 LP32PEB_,
  * __ptr64 P64PEB_, * __ptr64 LP64PEB_;


#ifdef _X86_
PTEB32_ GetCurrentTEB32(VOID) {
  __asm mov eax, fs:[18h]
}

PPEB32_ GetCurrentPEB32(VOID) {
  __asm mov eax, fs:[30h]
}
PTEB64_ GetCurrentTEB64(VOID) {
  __asm mov eax, gs:[30h]
}

PPEB64_ GetCurrentPEB64(VOID) {
  __asm mov eax, gs:[60h]
}
#else
PTEB64_ GetCurrentTEB64(VOID) {
  return(*(PTEB64_ *)((PBYTE)NtCurrentTeb()+0x30));
}

PPEB64_ GetCurrentPEB64(VOID) {
  return(*(PPEB64_ *)((PBYTE)NtCurrentTeb()+0x60));
}
#endif

typedef struct _PROCESS_BASIC_INFORMATION_ {
  NTSTATUS ExitStatus;
  PPEB_ PebBaseAddress;
  ULONG_PTR AffinityMask;
  LONG BasePriority;
  ULONG_PTR UniqueProcess;
  ULONG_PTR InheritedFromUniqueProcess;
} PROCESS_BASIC_INFORMATION_, *PPROCESS_BASIC_INFORMATION_, *LPPROCESS_BASIC_INFORMATION_,
  * __ptr32 P32PROCESS_BASIC_INFORMATION_, * __ptr32 LP32PROCESS_BASIC_INFORMATION_,
  * __ptr64 P64PROCESS_BASIC_INFORMATION_, * __ptr64 LP64PROCESS_BASIC_INFORMATION_;

typedef union _PROCESS_WOW64_INFORMATION_ {
  PPEB32_ Peb32BaseAddress;
} PROCESS_WOW64_INFORMATION_, *PPROCESS_WOW64_INFORMATION_, *LPPROCESS_WOW64_INFORMATION_;

typedef struct _UNICODE_STRING {
  USHORT Length;
  USHORT MaximumLength;
  PWSTR Buffer;
} UNICODE_STRING, *PUNICODE_STRING, *LPUNICODE_STRING;

typedef struct _SYSTEM_PROCESSES_X {
    ULONG NextEntryOffset;
    ULONG ThreadCount;
    ULONG Reserved1[6];
    LARGE_INTEGER CreateTime;
    LARGE_INTEGER UserTime;
    LARGE_INTEGER KernelTime;
    UNICODE_STRING ProcessName;
    LONG BasePriority;
    ULONG_PTR UniqueProcess;
    ULONG_PTR InheritedFromUniqueProcess;
} SYSTEM_PROCESSES_X, *PSYSTEM_PROCESSES_X;

#pragma comment(lib, "ntdll.lib")
#include "..\Wow64Api.h"
#ifdef __cplusplus
  extern "C" {
#endif
#ifndef _NTPROTO
#define _NTPROTO __declspec(dllimport) NTSTATUS WINAPI
#endif
_NTPROTO RtlAdjustPrivilege(DWORD, BOOL, ULONG, PULONG);
_NTPROTO NtQuerySystemInformation(ULONG, LPVOID, ULONG, PULONG);
_NTPROTO NtQueryInformationProcess(HANDLE, ULONG, LPVOID, DWORD, PDWORD);
#ifdef _X86_
#include "..\Kernel64Api.h"
#else
#define g_pZwWow64QueryInformationProcess64 NtQueryInformationProcess
#define ReadProcessMemory64 ReadProcessMemory
#endif
#ifdef __cplusplus
 }
#endif


VOID main(VOID) { 
  ULONG s;
  NTSTATUS NtStatus;
  PSYSTEM_PROCESSES_X pPInfo;
  HANDLE hProcess;
  PROCESS_BASIC_INFORMATION64_ pbi64;
  PROCESS_BASIC_INFORMATION_ pbi;
  PROCESS_WOW64_INFORMATION_ pwi;
  PLIST_ENTRY64_ pHead64;
  PLIST_ENTRY32_ pHead32;
  union {
    PEB32_ Peb32;
    PEB64_ Peb64;
    PEB_LDR_DATA32_ Ldr32;
    PEB_LDR_DATA64_ Ldr64;
    LIST_ENTRY32_ Le32;
    LIST_ENTRY64_ Le64;
    LDR_DATA_TABLE_ENTRY32_ Ldte32;
    LDR_DATA_TABLE_ENTRY64_ Ldte64;
  } Space;
  WCHAR FullDllNameW[260];
  CHAR b[1024];

  s = 0x10000;
  for(;;) {
    pPInfo = (PSYSTEM_PROCESSES_X)VirtualAlloc(NULL, s, MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
    if(pPInfo == NULL) {
      return;
    }
    NtStatus = NtQuerySystemInformation(5, pPInfo, s, NULL);
    if(NtStatus >= 0) {
      break;
    }
    VirtualFree(pPInfo, 0, MEM_RELEASE);
    if(NtStatus != 0xC0000004L) {
      return;
    }
    s += 0x8000;
  }

  RtlAdjustPrivilege(20, TRUE, FALSE, &s);
  GetWow64Api();

  do {
    if(pPInfo->UniqueProcess == 0) {
      _lwrite(STD_OUTPUT_HANDLE, b, sprintf(b, "\n   0    0 | ?? |    0    0 | Idle\n"));
    }
    else {
      hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, (DWORD)pPInfo->UniqueProcess);
      if(hProcess == NULL) {
        _lwrite(STD_OUTPUT_HANDLE, b, sprintf(b, "\n%4X %4u | %s | %4X %4u | %.260ws\n", pPInfo->UniqueProcess, pPInfo->UniqueProcess, "??", pPInfo->InheritedFromUniqueProcess, pPInfo->InheritedFromUniqueProcess, pPInfo->ProcessName.Buffer));
      }
      else {
        s = 0;
        if(g_pZwWow64QueryInformationProcess64 != NULL) {
          NtStatus = NtQueryInformationProcess(hProcess, 0x1A, &pwi, sizeof(pwi), NULL);
          _lwrite(STD_OUTPUT_HANDLE, b, sprintf(b, "\n%4X %4u | %s | %4X %4u | %.260ws\n", pPInfo->UniqueProcess, pPInfo->UniqueProcess, NtStatus < 0 ? "??" : (pwi.Peb32BaseAddress ? "32" : "64"), pPInfo->InheritedFromUniqueProcess, pPInfo->InheritedFromUniqueProcess, pPInfo->ProcessName.Buffer));
          NtStatus = g_pZwWow64QueryInformationProcess64(hProcess, 0x00, &pbi64, sizeof(pbi64), NULL);
          if((NtStatus >= 0) && pbi64.PebBaseAddress) {
            if(ReadProcessMemory64(hProcess, pbi64.PebBaseAddress, &Space.Peb64, sizeof(Space.Peb64), NULL)) {
              pHead64 = (P64LIST_ENTRY64_)((ULONGLONG)Space.Peb64.Ldr +((ULONGLONG)&Space.Ldr64.InLoadOrderModuleList -(ULONGLONG)&Space.Ldr64));
              if(ReadProcessMemory64(hProcess, Space.Peb64.Ldr, &Space.Ldr64, sizeof(Space.Ldr64), NULL)) {
                if(ReadProcessMemory64(hProcess, Space.Ldr64.InLoadOrderModuleList.Flink, &Space.Ldte64, sizeof(Space.Ldte64), NULL)) {
                  do {
                    if(!ReadProcessMemory64(hProcess, Space.Ldte64.FullDllName.Buffer, FullDllNameW, s = Space.Ldte64.FullDllName.Length, NULL)) {
                      FullDllNameW[0] = '?';
                      s = sizeof(WCHAR);
                    }
                    FullDllNameW[s/sizeof(WCHAR)] = '\0';
                    _lwrite(STD_OUTPUT_HANDLE, b, sprintf(b, "%.16I64X %.4X %.260ws\n", Space.Ldte64.DllBase, Space.Ldte64.LoadCount, FullDllNameW));
                  } while((pHead64 != Space.Le64.Flink) && ReadProcessMemory64(hProcess, Space.Le64.Flink, &Space.Ldte64, sizeof(Space.Ldte64), NULL));
                }
              }
            }
          }
        }
        else {
          NtStatus = NtQueryInformationProcess(hProcess, 0x00, &pbi, sizeof(pbi), NULL);
          pwi.Peb32BaseAddress = NtStatus >= 0 ? (PPEB32_)pbi.PebBaseAddress : NULL;
          _lwrite(STD_OUTPUT_HANDLE, b, sprintf(b, "\n%4X %4u | 32 | %4X %4u | %.260ws\n", pPInfo->UniqueProcess, pPInfo->UniqueProcess, pPInfo->InheritedFromUniqueProcess, pPInfo->InheritedFromUniqueProcess, pPInfo->ProcessName.Buffer));
        }
        if(pwi.Peb32BaseAddress) {
          if(ReadProcessMemory(hProcess, pwi.Peb32BaseAddress, &Space.Peb32, sizeof(Space.Peb32), NULL)) {
            pHead32 = (PLIST_ENTRY32_)((ULONG_PTR)Space.Peb32.Ldr +((ULONG_PTR)&Space.Ldr32.InLoadOrderModuleList -(ULONG_PTR)&Space.Ldr32));
            if(ReadProcessMemory(hProcess, Space.Peb32.Ldr, &Space, sizeof(Space.Ldr32), NULL)) {
              if(ReadProcessMemory(hProcess, Space.Ldr32.InLoadOrderModuleList.Flink, &Space.Ldte32, sizeof(Space.Ldte32), NULL)) {
                if(s) {
                  ReadProcessMemory(hProcess, Space.Le32.Flink, &Space.Ldte32, sizeof(Space.Ldte32), NULL);
                }
                do {
                  if(!ReadProcessMemory(hProcess, Space.Ldte32.FullDllName.Buffer, FullDllNameW, s = Space.Ldte32.FullDllName.Length, NULL)) {
                    FullDllNameW[0] = '?';
                    s = sizeof(WCHAR);
                  }
                  FullDllNameW[s/sizeof(WCHAR)] = '\0';
                  _lwrite(STD_OUTPUT_HANDLE, b, sprintf(b, "%.16I32X %.4X %.260ws\n", Space.Ldte32.DllBase, Space.Ldte32.LoadCount, FullDllNameW));
                } while((pHead32 != Space.Le32.Flink) && ReadProcessMemory(hProcess, Space.Le32.Flink, &Space.Ldte32, sizeof(Space.Ldte32), NULL));
              }
            }
          }
        }
      }
    }
    s = pPInfo->NextEntryOffset;
    pPInfo = (PSYSTEM_PROCESSES_X)((PBYTE)pPInfo +s);
  } while(s);

  VirtualFree(pPInfo, 0, MEM_RELEASE);
}
