#define _WIN32_WINNT 0x0501

#include <stdlib.h>
#include <tchar.h>
#include <windows.h>

#define _s(s) (sizeof(s)/sizeof(*s))

#define STRCMPI lstrcmpiA //stricmp
#include "..\Thunk64.h"

typedef struct _ANSI_STRING64 {
  WORD Length;
  WORD MaximumLength;
  DWORD align1;
  P64STR Buffer;
} ANSI_STRING64, *PANSI_STRING64;

typedef struct _UNICODE_STRING64 {
  WORD Length;
  WORD MaximumLength;
  DWORD align1;
  P64WSTR Buffer;
} UNICODE_STRING64, *PUNICODE_STRING64;


#define LDRGETPROCEDUREADDDRESS_NAMEA "LdrGetProcedureAddress"
#define LDRLOADDLL_NAMEA "LdrLoadDll"
#define GETPROCADDRESS_NAMEA "GetProcAddress"
#define LOADLIBRARYW_NAMEA "LoadLibraryW"
#define MESSAGEBOXW_NAMEA "MessageBoxW"

#define KERNEL32_NAMEW L"KERNEL32.DLL"
#define USER32_NAMEW L"USER32.DLL"


DWORD WINAPI MsgBox32(LPVOID lp) {
  return((DWORD)(DWORD (WINAPI *)(HANDLE, LPCWSTR, LPCWSTR, INT))GetProcAddress(LoadLibraryExW(USER32_NAMEW, NULL, 0), MESSAGEBOXW_NAMEA)(lp, L"from 32bit mode.", L"Hello", MB_OK));
}

VOID main(VOID) {
  DWORD n;
  LPVOID r, hNTDLL64;
  LPCVOID lpLdrGetProcedureAddress64;
  LP64CVOID h64KERNEL3264, h64USER3264, lp64LdrLoadDll64, lp64GetProcAddress64, lp64LoadLibraryW64, lp64MessageBoxW64;
  ANSI_STRING64 as64;
  UNICODE_STRING64 us64;
  WCHAR PathNameW[MAX_PATH];
  HANDLE hThread;

  hThread = CreateThread(NULL, 0, MsgBox32, NULL, 0, NULL);
  WaitForSingleObject(hThread, INFINITE);
  CloseHandle(hThread);
//  MessageBoxW(NULL, L"from 32bit mode.", L"Hello", MB_OK);

  Wow64DisableWow64FsRedirection(&r);

  lstrcpyW(PathNameW+(n = GetSystemDirectoryW(PathNameW, _s(PathNameW))), L"\\"KERNEL32_NAMEW); 
  hNTDLL64 = LoadLibraryExW(PathNameW, NULL, LOAD_LIBRARY_AS_DATAFILE);
  if(hNTDLL64) {
    VirtualFree((LPVOID)(ULONG)((PIMAGE_NT_HEADERS64)(((ULONG_PTR)hNTDLL64 & ~1) +((PIMAGE_DOS_HEADER)((ULONG_PTR)hNTDLL64 & ~1))->e_lfanew))->OptionalHeader.ImageBase, 0, MEM_RELEASE);
    FreeLibrary(hNTDLL64);
  }

  lstrcpyW(PathNameW+n+1, USER32_NAMEW); 
  hNTDLL64 = LoadLibraryExW(PathNameW, NULL, LOAD_LIBRARY_AS_DATAFILE);
  if(hNTDLL64) {
    VirtualFree((LPVOID)(ULONG)((PIMAGE_NT_HEADERS64)(((ULONG_PTR)hNTDLL64 & ~1) +((PIMAGE_DOS_HEADER)((ULONG_PTR)hNTDLL64 & ~1))->e_lfanew))->OptionalHeader.ImageBase, 0, MEM_RELEASE);
    FreeLibrary(hNTDLL64);
  }

  hNTDLL64 = Ptr64ToPtr(((PLDR_DATA_TABLE_ENTRY64_)GetCurrentPEB64()->Ldr->InLoadOrderModuleList.Flink->Flink)->DllBase);
  lpLdrGetProcedureAddress64 = thGetProcAddress64(hNTDLL64, LDRGETPROCEDUREADDDRESS_NAMEA);
  as64.Length = (as64.MaximumLength = sizeof(LDRLOADDLL_NAMEA)) - sizeof(*LDRLOADDLL_NAMEA);
  as64.Buffer = PtrToPtr64(LDRLOADDLL_NAMEA);
  ApiCall64(PtrToPtr64(lpLdrGetProcedureAddress64), 4, PtrToPtr64(hNTDLL64), PtrToPtr64(&as64), (ULONGLONG)0, PtrToPtr64(&lp64LdrLoadDll64));

  us64.Length = (us64.MaximumLength = sizeof(KERNEL32_NAMEW)) - sizeof(*KERNEL32_NAMEW);
  us64.Buffer = PtrToPtr64(KERNEL32_NAMEW);
  ApiCall64(lp64LdrLoadDll64, 4, (ULONGLONG)0, (ULONGLONG)0, PtrToPtr64(&us64), PtrToPtr64(&h64KERNEL3264));
  as64.Length = (as64.MaximumLength = sizeof(GETPROCADDRESS_NAMEA)) - sizeof(*GETPROCADDRESS_NAMEA);
  as64.Buffer = PtrToPtr64(GETPROCADDRESS_NAMEA);
  ApiCall64(PtrToPtr64(lpLdrGetProcedureAddress64), 4, h64KERNEL3264, PtrToPtr64(&as64), (ULONGLONG)0, PtrToPtr64(&lp64GetProcAddress64));
  lp64LoadLibraryW64 = ApiCall64(lp64GetProcAddress64, 2, h64KERNEL3264, PtrToPtr64(LOADLIBRARYW_NAMEA));

  h64USER3264 = ApiCall64(lp64LoadLibraryW64, 1, PtrToPtr64(USER32_NAMEW));
  lp64MessageBoxW64 = ApiCall64(lp64GetProcAddress64, 2, h64USER3264, PtrToPtr64(MESSAGEBOXW_NAMEA));
  ApiCall64(lp64MessageBoxW64, 4, PtrToPtr64(NULL), PtrToPtr64(L"from 64bit mode."), PtrToPtr64(L"Hello"), (ULONGLONG)MB_OK);

  //Wow64RevertWow64FsRedirection(r);
}
