
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include <windows.h>
#include <tlhelp32.h>

#include "..\ParseCL.h"

#define _s(s) (sizeof(s)/sizeof(*s))

#ifdef __cplusplus
  extern "C" {
#endif
__declspec(dllimport) LONG WINAPI RtlAdjustPrivilege(DWORD, BOOL, ULONG, PLONG);

LONG main(VOID) {
  TCHAR *argv[2];
  TCHAR b[2048];
  INT argc = ParseCommandLine(argv, _s(argv), b, _s(b));
  LONG n = RtlAdjustPrivilege(20, TRUE, 0, &n);
  HANDLE hSnap = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE | TH32CS_SNAPMODULE32, argc > 1 ? _tcstoul(argv[1], NULL, 0) : GetCurrentProcessId());
  n = 0;
  if(hSnap != INVALID_HANDLE_VALUE) {
    MODULEENTRY32 me = {sizeof me};
    if(Module32First(hSnap, &me)) {
      LPVOID ExeBase = me.modBaseAddr;
#ifdef _X86_
      _lwrite(STD_OUTPUT_HANDLE, b, sprintf(b, "%08X %04X %hs\n", me.modBaseAddr, me.ProccntUsage, me.szExePath));
#else
      _lwrite(STD_OUTPUT_HANDLE, b, sprintf(b, "%016I64X %04X %hs\n", me.modBaseAddr, me.ProccntUsage, me.szExePath));
#endif
      n++;
      do {
        if(ExeBase != me.modBaseAddr) {
#ifdef _X86_
          _lwrite(STD_OUTPUT_HANDLE, b, sprintf(b, "%08X %04X %hs\n", me.modBaseAddr, me.ProccntUsage, me.szExePath));
#else
          _lwrite(STD_OUTPUT_HANDLE, b, sprintf(b, "%016I64X %04X %hs\n", me.modBaseAddr, me.ProccntUsage, me.szExePath));
#endif
          n++;
        }
      } while(Module32Next(hSnap, &me));
    }
    CloseHandle(hSnap);
  }
  return(n);
}
