#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

#define _s(s) (sizeof(s)/sizeof(*s))

#include "..\ParseCL.h"
#include "..\Wow64Api.h"
#include "..\Kernel64Api.h"

LPCVOID GetCurrentTEB32(VOID) {
  __asm mov eax, fs:[18h]
}

LPCVOID GetCurrentPEB32(VOID) {
  __asm mov eax, fs:[30h]
}

LPCVOID GetCurrentTEB64(VOID) {
  __asm mov eax, gs:[30h]
}

LPCVOID GetCurrentPEB64(VOID) {
  __asm mov eax, gs:[60h]
}

#ifdef __cplusplus
  extern "C" {
#endif
__declspec(dllimport) LONG WINAPI RtlAdjustPrivilege(DWORD, BOOL, ULONG, PINT);

VOID main(VOID) {
  INT argc;
  CHAR *argv[2];
  HANDLE hProcess;
  MEMORY_BASIC_INFORMATION64_ mbi;
  LP64CVOID p = NULL;
  CHAR StringA[MAX_PATH+32];

  GetWow64Api();
  RtlAdjustPrivilege(20, TRUE, 0, &argc);
  argc = ParseCommandLine(argv, _s(argv), StringA, _s(StringA));
  hProcess = argc > 1 ? OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, strtoul(argv[1], NULL, 0)) : GetCurrentProcess();
  if(hProcess == NULL) {
    hProcess = OpenProcess(PROCESS_QUERY_INFORMATION, FALSE, strtoul(argv[1], NULL, 0));
    if(hProcess == NULL) {
      return;
    }
  }
  while(VirtualQueryEx64(hProcess, p, &mbi, sizeof(mbi))) {
    _lwrite(STD_OUTPUT_HANDLE, StringA, sprintf(StringA, "%.16I64X %.16I64X %.8X %.16I64X %.8X %.8X %.8X\n", mbi.BaseAddress, mbi.AllocationBase, mbi.AllocationProtect, mbi.RegionSize, mbi.State, mbi.Protect, mbi.Type));
    if((mbi.State & MEM_COMMIT) && !(mbi.Protect & PAGE_GUARD)) {
      LPVOID pBuffer = VirtualAlloc(NULL, (SIZE_T)mbi.RegionSize, MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
      if(pBuffer) {
        if(ReadProcessMemory64(hProcess, mbi.BaseAddress, pBuffer, (SIZE_T)mbi.RegionSize, NULL)) {
          HFILE hFile;
          sprintf(StringA, "%.16I64X.bin", mbi.BaseAddress);
          hFile = _lcreat(StringA, 0);
          if(hFile != HFILE_ERROR) {
            _lwrite(hFile, (LPCCH)pBuffer, (SIZE_T)mbi.RegionSize);
            CloseHandle((HANDLE)hFile);
          }
        }
        VirtualFree(pBuffer, 0, MEM_RELEASE);
      }
    }
    p = (LP64CVOID)((SIZE64_T)mbi.BaseAddress +mbi.RegionSize);
  }
  if(hProcess != GetCurrentProcess()) {
    CloseHandle(hProcess);
  }
  else {
    _lwrite(STD_OUTPUT_HANDLE, StringA, sprintf(StringA, "TEB64 %.8X  PEB64 %.8X\nTEB32 %.8X  PEB32 %.8X\n", GetCurrentTEB64(), GetCurrentPEB64(), GetCurrentTEB32(), GetCurrentPEB32()));
  }
}
